import {MastodonTokenHandler} from "./mastodonTokenHandler.js";
import {mastodonMemeBot} from "./mastodonMemeBot.js";
import {loadData} from "./JSONdataStore.js";

const config = loadData("./config.json")??{
    baseUrl: "https://social.cybre.town",
    memeAPI: "http://redditapi.adb.sh/api/v1/",
    subreddits: ["r/programmerhumor/random"],
    allowedMedia: ["jpg", "jpeg", "gif", "png"],
    interval: 60
};

let tokenHandler = new MastodonTokenHandler(config);
tokenHandler.getAccessToken((accessToken) => {
    config.accessToken = accessToken;
    let bot = new mastodonMemeBot(config);
    bot.setFullInterval(config.interval);
});
